#Dynamical Task Switching in Cellular Computers
# @AngelGMoreno

import scipy
from scipy import integrate
from pylab import *
from operator import itemgetter
import numpy as np

v = scipy.zeros((4),'d')
def rate_eqs(S):
    A=S[0]; B=S[1]
    v[0] = k1 * A
    v[1] = k2 * A * B
    v[2] = k1 * B
    v[3] = k_deg * B
    return v

def diff_eqs(S,t):
    Sdot = scipy.zeros((2),'d')
    v = rate_eqs(S)
    Sdot[0] =  0#+ v[0] - v[3]
    Sdot[1] =  - v[1] + v[2]  #- v[3]
    return Sdot

A=B=100
k1=0.05
k2=0.005
k_deg=0.004

lines = []
i=0.00048
while i<.00052:

	A=B=100
	k2=i
	t_start=0.0; t_end=2000.0; t_inc=1.
	t_range = scipy.arange(t_start, t_end+t_inc, t_inc)
	t_course = scipy.integrate.odeint(diff_eqs, [A,B], t_range)
	#plot(t_range, map(itemgetter(1),t_course))
	lines.append(map(itemgetter(1),t_course))

	i=i+0.0000008

color_idx = np.linspace(0, 1, len(lines))
for i,l in zip(color_idx, range(len(lines))):
    plot(t_range, lines[l], color=plt.cm.PuOr(i), lw=2)

yscale('log')


show()

